package com.jenny.magic.particles;

import net.minecraft.client.Minecraft;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.util.RandomSource;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.Vec3;

import javax.annotation.Nullable;

public class effects {
    public static void executeEffect(EFFECT effect, @Nullable Vec3 origin) {
        switch (effect) {
            case WAND_VACUUM -> wandVacuum(origin);
            case SCROLL_TELEPORT_ORIGIN -> teleportOrigin(origin);
            case SCROLL_TELEPORT_TARGET -> teleportTarget(origin);
        }
    }

    private static void teleportOrigin(Vec3 v) {
        for (int i = 0; i < 20; i++) {
            Vec3 randPos = randPos(1);
            Vec3 pos = v.add(randPos);
            Vec3 delta = randPos.scale(-0.1);
            level().addParticle(ParticleTypes.GLOW_SQUID_INK, pos.x, pos.y, pos.z, delta.x, delta.y, delta.z);
        }
    }

    private static void teleportTarget(Vec3 v) {
        for (int i = 0; i < 20; i++) {
            Vec3 randPos = randPosRandDist(0.2f);
            level().addParticle(ParticleTypes.GLOW_SQUID_INK, v.x, v.y, v.z, randPos.x, randPos.y, randPos.z);
        }
    }

    private static void wandVacuum(Vec3 v) {
        for (int i = 0; i < 20; i++) {
            Vec3 randPos = randPos2D(5);
            Vec3 pos = v.add(randPos);
            Vec3 delta = randPos.scale(-0.1).add(0, 0.2, 0);
            level().addParticle(ParticleTypes.GLOW_SQUID_INK, pos.x, pos.y, pos.z, delta.x, delta.y, delta.z);
        }
    }

    public static Vec3 randPos(float maxDist) {
        return new Vec3(
                rng().nextFloat() * 2 - 1,
                rng().nextFloat() * 2 - 1,
                rng().nextFloat() * 2 - 1).normalize().scale(maxDist);
    }

    public static Vec3 randPos2D(float maxDist) {
        return new Vec3(
                rng().nextFloat() * 2 - 1,
                0,
                rng().nextFloat() * 2 - 1).normalize().scale(maxDist);
    }

    public static Vec3 randPosRandDist(float maxDist) {
        return new Vec3(
                rng().nextFloat() * 2 - 1,
                rng().nextFloat() * 2 - 1,
                rng().nextFloat() * 2 - 1).normalize().scale(rng().nextFloat() * maxDist);
    }

    private static Level level() {
        return Minecraft.getInstance().level;
    }

    private static RandomSource rng() {
        return level().getRandom();
    }

    public enum EFFECT {
        SCROLL_TELEPORT_ORIGIN,
        SCROLL_TELEPORT_TARGET,
        SCROLL_HEALTH,
        SCROLL_REPEL,
        SCROLL_WITHER,
        SCROLL_BONEMEAL,
        WAND_VACUUM
    }
}
